import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataConsulAclTokenSecretIdConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/consul/d/acl_token_secret_id#accessor_id DataConsulAclTokenSecretId#accessor_id}
    */
    readonly accessorId: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/consul/d/acl_token_secret_id#id DataConsulAclTokenSecretId#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/consul/d/acl_token_secret_id#namespace DataConsulAclTokenSecretId#namespace}
    */
    readonly namespace?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/consul/d/acl_token_secret_id#partition DataConsulAclTokenSecretId#partition}
    */
    readonly partition?: string;
    /**
    * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/consul/d/acl_token_secret_id#pgp_key DataConsulAclTokenSecretId#pgp_key}
    */
    readonly pgpKey?: string;
}
/**
* Represents a {@link https://www.terraform.io/docs/providers/consul/d/acl_token_secret_id consul_acl_token_secret_id}
*/
export declare class DataConsulAclTokenSecretId extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "consul_acl_token_secret_id";
    /**
    * Create a new {@link https://www.terraform.io/docs/providers/consul/d/acl_token_secret_id consul_acl_token_secret_id} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataConsulAclTokenSecretIdConfig
    */
    constructor(scope: Construct, id: string, config: DataConsulAclTokenSecretIdConfig);
    private _accessorId?;
    get accessorId(): string;
    set accessorId(value: string);
    get accessorIdInput(): string | undefined;
    get encryptedSecretId(): string;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _namespace?;
    get namespace(): string;
    set namespace(value: string);
    resetNamespace(): void;
    get namespaceInput(): string | undefined;
    private _partition?;
    get partition(): string;
    set partition(value: string);
    resetPartition(): void;
    get partitionInput(): string | undefined;
    private _pgpKey?;
    get pgpKey(): string;
    set pgpKey(value: string);
    resetPgpKey(): void;
    get pgpKeyInput(): string | undefined;
    get secretId(): string;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
